## john 1.7.3.1

=== src/Makefile ===
--- 
+++ 
@@ -1,12 +1,12 @@
 #
 # This file is part of John the Ripper password cracker,
-# Copyright (c) 1996-2006 by Solar Designer
+# Copyright (c) 1996-2008 by Solar Designer
 #
 
-CPP = gcc
 CC = gcc
-AS = gcc
-LD = gcc
+AS = $(CC)
+LD = $(CC)
+CPP = $(CC)
 CP = cp
 LN = ln -sf
 RM = rm -f
@@ -56,13 +56,13 @@
 	MD5_fmt.o MD5_std.o
 
 BENCH_BF_OBJS_DEPEND = \
-	BF_std.o
+	BF_fmt.o BF_std.o
 
 BENCH_OBJS = \
 	$(BENCH_DES_OBJS_DEPEND) \
 	DES_bs.o $(BENCH_DES_BS_OBJS_DEPEND) \
 	$(BENCH_MD5_OBJS_DEPEND) \
-	BF_fmt.o $(BENCH_BF_OBJS_DEPEND) \
+	$(BENCH_BF_OBJS_DEPEND) \
 	bench.o best.o common.o config.o formats.o math.o memory.o miscnl.o \
 	params.o path.o signals.o tty.o
 
@@ -76,27 +76,28 @@
 	@echo "To build John the Ripper, type:"
 	@echo "	make clean SYSTEM"
 	@echo "where SYSTEM can be one of the following:"
-	@echo "linux-x86-sse2           Linux, x86 with SSE2 (best)"
+	@echo "linux-x86-64             Linux, x86-64 with SSE2 (best)"
+#	@echo "linux-x86-64-32-sse2     Linux, x86-64, 32-bit with SSE2"
+#	@echo "linux-x86-64-32-mmx      Linux, x86-64, 32-bit with MMX"
+	@echo "linux-x86-sse2           Linux, x86 with SSE2 (best if 32-bit)"
 	@echo "linux-x86-mmx            Linux, x86 with MMX"
 	@echo "linux-x86-any            Linux, x86"
-	@echo "linux-x86-64             Linux, AMD x86-64 with SSE2"
-#	@echo "linux-x86-64-32-sse2     Linux, AMD x86-64, 32-bit with SSE2"
-#	@echo "linux-x86-64-32-mmx      Linux, AMD x86-64, 32-bit with MMX"
 	@echo "linux-alpha              Linux, Alpha"
 	@echo "linux-sparc              Linux, SPARC 32-bit"
 	@echo "linux-ppc32-altivec      Linux, PowerPC w/AltiVec (best)"
 	@echo "linux-ppc32              Linux, PowerPC 32-bit"
 #	@echo "linux-ppc64-altivec      Linux, PowerPC 64-bit w/AltiVec"
 	@echo "linux-ppc64              Linux, PowerPC 64-bit"
-	@echo "freebsd-x86-sse2         FreeBSD, x86 with SSE2 (best)"
+	@echo "linux-ia64               Linux, IA-64"
+	@echo "freebsd-x86-64           FreeBSD, x86-64 with SSE2 (best)"
+	@echo "freebsd-x86-sse2         FreeBSD, x86 with SSE2 (best if 32-bit)"
 	@echo "freebsd-x86-mmx          FreeBSD, x86 with MMX"
 	@echo "freebsd-x86-any          FreeBSD, x86"
-	@echo "freebsd-x86-64           FreeBSD, AMD x86-64 with SSE2"
 	@echo "freebsd-alpha            FreeBSD, Alpha"
-	@echo "openbsd-x86-sse2         OpenBSD, x86 with SSE2 (best)"
+	@echo "openbsd-x86-64           OpenBSD, x86-64 with SSE2 (best)"
+	@echo "openbsd-x86-sse2         OpenBSD, x86 with SSE2 (best if 32-bit)"
 	@echo "openbsd-x86-mmx          OpenBSD, x86 with MMX"
 	@echo "openbsd-x86-any          OpenBSD, x86"
-	@echo "openbsd-x86-64           OpenBSD, AMD x86-64 with SSE2"
 	@echo "openbsd-alpha            OpenBSD, Alpha"
 	@echo "openbsd-sparc64          OpenBSD, SPARC 64-bit (best)"
 	@echo "openbsd-sparc            OpenBSD, SPARC 32-bit"
@@ -111,16 +112,25 @@
 	@echo "solaris-sparcv9-cc       Solaris, SPARC V9 32-bit, cc"
 	@echo "solaris-sparcv8-cc       Solaris, SPARC V8 32-bit, cc"
 	@echo "solaris-sparc-gcc        Solaris, SPARC 32-bit, gcc"
-	@echo "solaris-x86-any          Solaris, x86, gcc"
+	@echo "solaris-x86-64-cc        Solaris, x86-64 with SSE2, cc (best)"
+	@echo "solaris-x86-64-gcc       Solaris, x86-64 with SSE2, gcc"
+	@echo "solaris-x86-sse2-cc      Solaris 9 4/04+, x86 with SSE2, cc"
+	@echo "solaris-x86-sse2-gcc     Solaris 9 4/04+, x86 with SSE2, gcc"
+	@echo "solaris-x86-mmx-cc       Solaris, x86 with MMX, cc"
+	@echo "solaris-x86-mmx-gcc      Solaris, x86 with MMX, gcc"
+	@echo "solaris-x86-any-cc       Solaris, x86, cc"
+	@echo "solaris-x86-any-gcc      Solaris, x86, gcc"
 	@echo "sco-x86-any-gcc          SCO, x86, gcc"
 	@echo "sco-x86-any-cc           SCO, x86, cc"
 	@echo "tru64-alpha              Tru64 (Digital UNIX, OSF/1), Alpha"
 	@echo "aix-ppc32                AIX, PowerPC 32-bit"
+	@echo "macosx-x86-64            Mac OS X 10.5+, Xcode 3.0+, x86-64 with SSE2 (best)"
+	@echo "macosx-x86-sse2          Mac OS X, x86 with SSE2"
 	@echo "macosx-ppc32-altivec     Mac OS X, PowerPC w/AltiVec (best)"
 	@echo "macosx-ppc32             Mac OS X, PowerPC 32-bit"
 #	@echo "macosx-ppc64-altivec     Mac OS X, PowerPC 64-bit w/AltiVec"
 	@echo "macosx-ppc64             Mac OS X 10.4+, PowerPC 64-bit"
-	@echo "macosx-x86-sse2          Mac OS X, x86 with SSE2"
+	@echo "macosx-universal         Mac OS X, Universal Binary (x86 + x86-64 + PPC)"
 	@echo "hpux-pa-risc-gcc         HP-UX, PA-RISC, gcc"
 	@echo "hpux-pa-risc-cc          HP-UX, PA-RISC, ANSI cc"
 	@echo "irix-mips64-r10k         IRIX, MIPS 64-bit (R10K) (best)"
@@ -136,27 +146,6 @@
 	@echo "beos-x86-any             BeOS, x86"
 	@echo "generic                  Any other Unix-like system with gcc"
 
-linux-x86-sse2:
-	$(LN) x86-sse.h arch.h
-	$(MAKE) $(PROJ) \
-		JOHN_OBJS="$(JOHN_OBJS_MINIMAL) x86.o x86-sse.o"
-
-linux-x86-mmx:
-	$(LN) x86-mmx.h arch.h
-	$(MAKE) $(PROJ) \
-		JOHN_OBJS="$(JOHN_OBJS_MINIMAL) x86.o x86-mmx.o"
-
-linux-x86-any:
-	$(LN) x86-any.h arch.h
-	$(MAKE) $(PROJ) \
-		JOHN_OBJS="$(JOHN_OBJS) x86.o"
-
-linux-x86-any-a.out:
-	$(LN) x86-any.h arch.h
-	$(MAKE) $(PROJ) \
-		JOHN_OBJS="$(JOHN_OBJS) x86.o" \
-		ASFLAGS="$(ASFLAGS) -DUNDERSCORES -DALIGN_LOG"
-
 linux-x86-64:
 	$(LN) x86-64.h arch.h
 	$(MAKE) $(PROJ) \
@@ -178,6 +167,27 @@
 		ASFLAGS="$(ASFLAGS) -m32" \
 		LDFLAGS="$(LDFLAGS) -m32"
 
+linux-x86-sse2:
+	$(LN) x86-sse.h arch.h
+	$(MAKE) $(PROJ) \
+		JOHN_OBJS="$(JOHN_OBJS_MINIMAL) x86.o x86-sse.o"
+
+linux-x86-mmx:
+	$(LN) x86-mmx.h arch.h
+	$(MAKE) $(PROJ) \
+		JOHN_OBJS="$(JOHN_OBJS_MINIMAL) x86.o x86-mmx.o"
+
+linux-x86-any:
+	$(LN) x86-any.h arch.h
+	$(MAKE) $(PROJ) \
+		JOHN_OBJS="$(JOHN_OBJS) x86.o"
+
+linux-x86-any-a.out:
+	$(LN) x86-any.h arch.h
+	$(MAKE) $(PROJ) \
+		JOHN_OBJS="$(JOHN_OBJS) x86.o" \
+		ASFLAGS="$(ASFLAGS) -DUNDERSCORES -DALIGN_LOG"
+
 linux-alpha:
 	$(LN) alpha.h arch.h
 	$(MAKE) $(PROJ) \
@@ -189,7 +199,7 @@
 	$(LN) alpha.h arch.h
 	$(MAKE) $(PROJ) \
 		JOHN_OBJS="$(JOHN_OBJS) alpha.o" \
-		CPP=ccc CC=ccc AS=ccc LD=ccc \
+		CC=ccc \
 		CFLAGS="-c -Wf,-switch,noil_schedule" \
 		OPT_NORMAL="-fast" \
 		OPT_INLINE="-O2 -arch host"
@@ -227,6 +237,15 @@
 ppc-alti-linux.o: ppc-alti.c DES_bs_a.c
 	$(CC) $(CFLAGS) $(OPT_INLINE) -maltivec ppc-alti.c -o $@
 
+linux-ia64:
+	$(LN) ia64.h arch.h
+	$(MAKE) $(PROJ)
+
+freebsd-x86-64:
+	$(LN) x86-64.h arch.h
+	$(MAKE) $(PROJ) \
+		JOHN_OBJS="$(JOHN_OBJS_MINIMAL) x86-64.o"
+
 freebsd-x86-sse2:
 	$(LN) x86-sse.h arch.h
 	$(MAKE) $(PROJ) \
@@ -251,16 +270,16 @@
 		JOHN_OBJS="$(JOHN_OBJS) x86.o" \
 		ASFLAGS="$(ASFLAGS) -DUNDERSCORES -DALIGN_LOG -DBSD"
 
-freebsd-x86-64:
-	$(LN) x86-64.h arch.h
-	$(MAKE) $(PROJ) \
-		JOHN_OBJS="$(JOHN_OBJS_MINIMAL) x86-64.o"
-
 freebsd-alpha:
 	$(LN) alpha.h arch.h
 	$(MAKE) $(PROJ) \
 		JOHN_OBJS="$(JOHN_OBJS) alpha.o"
 
+openbsd-x86-64:
+	$(LN) x86-64.h arch.h
+	$(MAKE) $(PROJ) \
+		JOHN_OBJS="$(JOHN_OBJS_MINIMAL) x86-64.o"
+
 openbsd-x86-sse2:
 	$(LN) x86-sse.h arch.h
 	$(MAKE) $(PROJ) \
@@ -284,11 +303,6 @@
 	$(MAKE) $(PROJ) \
 		JOHN_OBJS="$(JOHN_OBJS) x86.o" \
 		ASFLAGS="$(ASFLAGS) -DUNDERSCORES -DALIGN_LOG -DBSD"
-
-openbsd-x86-64:
-	$(LN) x86-64.h arch.h
-	$(MAKE) $(PROJ) \
-		JOHN_OBJS="$(JOHN_OBJS_MINIMAL) x86-64.o"
 
 openbsd-alpha:
 	$(LN) alpha.h arch.h
@@ -357,7 +371,7 @@
 solaris-sparc64-cc:
 	$(LN) sparc64.h arch.h
 	$(MAKE) $(PROJ) \
-		CPP=cc CC=cc AS=cc LD=cc \
+		CC=cc \
 		CFLAGS="-c -fast -xarch=native64" \
 		LDFLAGS="-s -xarch=native64 -lc -lrt" \
 		OPT_NORMAL="" \
@@ -388,29 +402,5 @@
 	$(MAKE) $(NAIL) \
 		BENCH_DES_OBJS_DEPEND="$(BENCH_DES_OBJS_ORIG) spro-sparc.o" \
 		JOHN_OBJS="$(JOHN_OBJS_ORIG) spro-sparc.o" \
-		CPP=cc CC=cc AS=cc LD=cc \
+		CC=cc \
 		CFLAGS="-c -xO4 -xarch=v8plusa -xchip=ultra" \
-		LDFLAGS="-s -lc -lrt" \
-		OPT_NORMAL="" \
-		OPT_INLINE="-xinline=s1,s2,s3,s4,s5,s6,s7,s8"
-
-use-solaris-sparcv8-cc:
-	$(MAKE) $(NAIL) \
-		BENCH_DES_OBJS_DEPEND="$(BENCH_DES_OBJS_ORIG) spro-sparc.o" \
-		JOHN_OBJS="$(JOHN_OBJS_ORIG) spro-sparc.o" \
-		CPP=cc CC=cc AS=cc LD=cc \
-		CFLAGS="-c -xO4 -xarch=v8" \
-		LDFLAGS="-s -lc -lrt" \
-		OPT_NORMAL="" \
-		OPT_INLINE="-xinline=s1,s2,s3,s4,s5,s6,s7,s8"
-
-use-solaris-sparc-gcc:
-	$(MAKE) $(NAIL) \
-		BENCH_DES_OBJS_DEPEND="$(BENCH_DES_OBJS_ORIG) sparc.o" \
-		JOHN_OBJS="$(JOHN_OBJS_ORIG) sparc.o" \
-		LDFLAGS="$(LDFLAGS) -lrt"
-
-sparc.h:
-	$(RM) arch.h
-	$(CC) $(CFLAGS) -DOS_TIMER -DOS_FLOCK -DDES_ASM detect.c
-	$(LD) $(LDFLAGS) detect.o -o detect
