## john 1.7.6-0

=== debian/changelog ===
john (1.7.6-0) stable; urgency=low

  01/06/11(1.7.6-0)
          >+First Maemo release.


 -- humble <<humblemaemo@gmail.com>>  Fri, 28 Jan 2011 06:15:45 +0000
