=== debian/control ===
Source: john
Section: user/development
Priority: extra
Maintainer: humble <<humblemaemo@gmail.com>>
Build-Depends: debhelper (>= 5)
Standards-Version: 3.7.2

Package: john
XB-Maemo-Display-Name: John The Ripper
Architecture: armel
Depends: 
Suggests: 
Description: John the Ripper password cracker.
XB-Maemo-Upgrade-Description: 
XSBC-Bugtracker:
