=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1




CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp
	dh_testdir
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# ======================================================
	#$(MAKE) DESTDIR="$(CURDIR)/debian/john" install
	mkdir -p "$(CURDIR)/debian/john"

	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "all.chr" "$(CURDIR)/debian/john/home/opt/John/all.chr"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "alnum.chr" "$(CURDIR)/debian/john/home/opt/John/alnum.chr"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "alpha.chr" "$(CURDIR)/debian/john/home/opt/John/alpha.chr"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "digits.chr" "$(CURDIR)/debian/john/home/opt/John/digits.chr"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "john" "$(CURDIR)/debian/john/home/opt/John/john"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "john.conf" "$(CURDIR)/debian/john/home/opt/John/john.conf"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "lanman.chr" "$(CURDIR)/debian/john/home/opt/John/lanman.chr"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "mailer" "$(CURDIR)/debian/john/home/opt/John/mailer"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "passwd" "$(CURDIR)/debian/john/home/opt/John/passwd"
	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
	cp -a "password.lst" "$(CURDIR)/debian/john/home/opt/John/password.lst"

	# ======================================================

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs debian/changelog
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
