## john 1.7.6-1

=== debian/changelog ===
john (1.7.6-1) stable; urgency=low

  01/29/11(1.7.6-1)
          >+The jumbo patch for 1.7.6, revision 9, This patch integrates lots of contributed patches adding support for over 40 of additional hash and cipher types (including popular ones such as NTLM, raw MD5, etc.), as well as some optimizations and features. Most likely, this is the only patch you may need to apply. Requires OpenSSL 0.9.7+.


 --  <<humblemaemo@gmail.com>>  Sat, 29 Jan 2011 20:10:56 +0000
