=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: john
 Section: user/development
 Priority: extra
-Maintainer: humble <<humblemaemo@gmail.com>>
+Maintainer:  <<humblemaemo@gmail.com>>
 Build-Depends: debhelper (>= 5)
 Standards-Version: 3.7.2
