=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,13 @@
 	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
 	cp -a "alpha.chr" "$(CURDIR)/debian/john/home/opt/John/alpha.chr"
 	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "calc_stat" "$(CURDIR)/debian/john/home/opt/John/calc_stat"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
 	cp -a "digits.chr" "$(CURDIR)/debian/john/home/opt/John/digits.chr"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "genincstats.rb" "$(CURDIR)/debian/john/home/opt/John/genincstats.rb"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "genmkvpwd" "$(CURDIR)/debian/john/home/opt/John/genmkvpwd"
 	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
 	cp -a "john" "$(CURDIR)/debian/john/home/opt/John/john"
 	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
@@ -65,11 +71,27 @@
 	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
 	cp -a "lanman.chr" "$(CURDIR)/debian/john/home/opt/John/lanman.chr"
 	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "ldif2pw.pl" "$(CURDIR)/debian/john/home/opt/John/ldif2pw.pl"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
 	cp -a "mailer" "$(CURDIR)/debian/john/home/opt/John/mailer"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "mkvcalcproba" "$(CURDIR)/debian/john/home/opt/John/mkvcalcproba"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "netntlm.pl" "$(CURDIR)/debian/john/home/opt/John/netntlm.pl"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "netscreen.py" "$(CURDIR)/debian/john/home/opt/John/netscreen.py"
 	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
 	cp -a "passwd" "$(CURDIR)/debian/john/home/opt/John/passwd"
 	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
 	cp -a "password.lst" "$(CURDIR)/debian/john/home/opt/John/password.lst"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "sap_prepare.pl" "$(CURDIR)/debian/john/home/opt/John/sap_prepare.pl"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "sha-dump.pl" "$(CURDIR)/debian/john/home/opt/John/sha-dump.pl"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "sha-test.pl" "$(CURDIR)/debian/john/home/opt/John/sha-test.pl"
+	mkdir -p "$(CURDIR)/debian/john/home/opt/John/"
+	cp -a "tgtsnarf" "$(CURDIR)/debian/john/home/opt/John/tgtsnarf"
 
 	# ======================================================
